/***************************************************************************
                          main.c  -  description
                             -------------------
    begin                : Mon Jan 13 17:35:11 CET 2003
    copyright            : (C) 2003 by johanneshub
    email                : johanneshub@foni.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/* Very experimental code. No warranty at all.

    start
    ./configure
    to make the makefile and compile the source with
    make

    use DUSBDEBUG for debug info

    main.c version 0.14b  12.08.2003 Johannes Hub

    This source is based of the file register.h from Michael Cohen

    History:
    0.14b 21.08.03 Johannes Hub
    u_scanner.c included, thats the direct way to the scanner module.
    

    0.14a 26.01.03 Johannes Hub
    Regeditor added for movement investigation.
    scan_75dpi_gray added, but
    it doesn't work at the moment.I see this problem by all
    resolutions at the moment

    0.14 14.01.03 Johannes Hub
    Moved into KDevelop 2.1.3, scan_150dpi_16_color added, but
    it doesn't work at the moment.I see this problem by all
    resolutions at the moment

    0.13 05.01.03 Johannes Hub
    I'm unsing now a speciale patched version from snoopy ver 1.3.

    0.12 16.12.02 Johannes Hub
    Full Scanner callibriation included.

    0.11 06.11.02 Johannes Hub
    Start of my investigation, the version from Michael doesn't work,
    the lamp is off by scanning.
    I'm using the out put from snoopy ver 1.3 to modify the source and
    the disassembled listings of the hpg4400.dll and rts8891u.dll.
*/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

/*#define TEST                                                  **/
#define DEBUG  // on/off for additional debug output        /**/
/*#define USBDEBUG  // on/off for additional debug output       **/
/*#define REG_EDIT  // on/off for reg_editor or normal program  **/
#define M_SCANNER  // on/off for scannermodule or usb-LIB     /**/

#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <stdlib.h>

#ifndef M_SCANNER
/* I'm include direct the usblib  */
#include "error.h"
#include "error.c"
#include "descriptors.c"
#include "linux.c"
#include "usb.c"
/* end of usb lib */

#include "usb_stuff.h"  // usblib headerfile
/* usb_stuff.h :
   by kernel version 2.4.18 and later (i don't know
   the switch version, 2.4.10 don't need it), you must
   include additional the usb_claim_interface function :
"  if ( (device_handle = open_device(device)) ){"
	     if (usb_claim_interface(device_handle, 0) < 0)
	     {
//               message( "ERROR: usb_claim_interface failed\n");
               usb_close(device_handle);
	       return 0;

             } else{
                message( "Device %s on bus, %s Vendor 0x%x Product 0x%x claimed.\n",device->filename,device->bus->dirname,device->descriptor.idVendor,device->descriptor.idProduct);
	       return device_handle;
             };
*/
#endif /* M_SCANNER */


#ifdef M_SCANNER
#include "u_scanner.c" 
#endif

#include "hp4470c.h"    // the hp4470c interface

#ifdef TEST
extern void RT_ReadEEPROM(void);
extern int RT_GetVersion(void);
#endif

/****************************************************************************/
void poll_buttons(){
/****************************************************************************/
  int exit = 1;
  int i;

  while(exit)
  {
    i=check_button();
    if(i){
      write_reg(0x25,0); //Reset the registers
      write_reg(0x1a,0);
    };

    if(i&0x0001) printf("You pressed +\n");
    if(i&0x0002) printf("You pressed -\n");
    if(i&0x0004) printf("You pressed print\n");
    if(i&0x0008) printf("You pressed email\n");
    if(i&0x0010) printf("You pressed copy\n");
    if(i&0x0020) printf("You pressed www\n");
    if(i&0x0040)
    {
      printf("You pressed scan\n");
      scan_pv_color(197,10,2600);
      scan_600dpi_color(197,10,2600);
    };
    if(i&0x0080)
    {
       printf("You pressed power ");
       if (scanner_is_on)
       {
         switch_off();
         scanner_is_on = FALSE;
         printf("off\n");
       } else
       {
         switch_on();
         scanner_is_on = TRUE;
         color_mode = TRUE;
         printf("on\n");
       };
    };
    if(i&0x0100) { printf("You pressed triangle ->EXIT\n"); exit = 0; };
    if(i&0x0200) printf("You pressed spanner\n");
    if(i&0x0400)
    {
       printf("You pressed color/bw, switch in to the ");
       if (color_mode)
       {
         switch_to_bw();
         color_mode = FALSE;
         printf("black/white mode\n");
       } else
       {
         switch_to_color();
         color_mode = TRUE;
         printf("color mode\n");
       };
    };

    // I guess we could do something useful here ????
    sleep(1);
  };
};



/****************************************************************************/
int question (const char *question)
/****************************************************************************/
{
  fputs (question, stdout);
  while (1)
    {
      int c, answer;
      /* Write a space to separate answer from question. */
      fputc (' ', stdout);
      /* Read the first character of the line.
         This should be the answer character, but might not be. */
      c = /*lower*/fgetc (stdin);
      answer = c;
      /* Discard rest of input line. */
      while (c != '\n' && c != EOF)
        c = fgetc (stdin);
      /* Obey the answer if it was valid. */
      if (answer == 'y')
        return 1;
      if (answer == 'n')
        return 0;
      /* Answer was invalid: ask for valid answer. */
      fputs ("Please answer y or n:", stdout);
    }
}

/****************************************************************************/
unsigned int get_keyboard (const char *question)
/****************************************************************************/
{
  int c, answer;

  fputs (question, stdout);
  c = fgetc (stdin);
  answer = c;
  /* Discard rest of input line. */
  while (c != '\n' && c != EOF)
    c = fgetc (stdin);
  return(answer);
}


/****************************************************************************/
unsigned int str_to_int( int n ){
/****************************************************************************/
/* that was a fast convert in few minutes,
   enough for me */
 if ( n < 0x3a )
   { n = n - 0x30; }
 else
   { n = n - 0x57; };
 return(n & 0xff);
};   


/****************************************************************************/
unsigned int get_value (const char *question)
/****************************************************************************/
/* that was a fast code in few minutes,
   enough for me */
{
  int c, i,n;
  unsigned char inputstring[256];

      inputstring[0] = 0x00;
      inputstring[1] = 0x00;
      inputstring[2] = 0x00;
      inputstring[3] = 0x00;
      inputstring[4] = 0x00;
      inputstring[5] = 0x00;
      inputstring[6] = 0x00;
      inputstring[7] = 0x00;
      fputs (question, stdout);
      fputc (' ', stdout);
      c = fgetc (stdin);
      i = 0;
      inputstring[i] = c;
      i++;
      /* Discard rest of input line. */
      while (c != '\n' && c != EOF)
      {
        c = fgetc (stdin);
        inputstring[i] = c;
        i++;
      }
      if (i > 2){
      n = (str_to_int( (int) inputstring[1] )& 0x0f ) |
         ((str_to_int( (int) inputstring[0] )& 0x0f )<<4);}
      else
        n= (str_to_int( (int) inputstring[0] )& 0x0f );
//      printf("Return 0x%x\n",n);
      return(n);
}


/****************************************************************************/
int dump_registers(int read_regs){
/****************************************************************************/
/* that was a fast code in few minutes,
   enough for me */
  unsigned char abReg[256],i;

  printf("    ");
  for (i=0; i < 16; i++)
    printf(" %02X", i);

  if (read_regs){
    printf("read regs from scanner..\n");
    memset (abReg, 0x55, sizeof (abReg));
    for (i = 0; i < 244; i++)
      abReg[i] = read_reg(i);
    DumpHex (abReg, sizeof (abReg), 16);}
  else
    DumpHex (registers, sizeof (registers), 16);
  return(0);
};



/****************************************************************************/
void reg_editor(void){
/****************************************************************************/
/* that is a register editor wrote in few minutes,
   enough for me */
//  FILE *FD; //test.pnm file
  int exit = 1;
  int length,x1,x2;
//  unsigned char *data_s;
  unsigned char v;
  unsigned int data_count;
  unsigned int c,size;
  unsigned char reg,value,value1,value2;

  printf("Reg_editor started, type h and enter for help\n");
  printf("All inputs in hex\n");

  while(exit)
  {
    c = get_keyboard (">");

    switch(c) {

      case '-':
        printf("Lamp intensity to weakest mode\n");
        write_reg(0xda,0xff);
        break;

      case '+':
        printf("Lamp intensity to normal mode\n");
        write_reg(0xda,0xa7);
        break;

      case 'l':
        printf("load regs\n");
        reg = get_value ("Load register arry :");
        init_array(reg,FALSE);
        break;

      case '0':
        printf("stop moving\n");
        write_reg(MOVE_START_STOP,0);
        break;

      case '1':
        printf("send single reg\n");
        reg = get_value ("Register :");
        value = get_value ("Value 1 :");
        write_reg(reg,value);
        break;

      case '2':
        printf("send double reg\n");
        reg = get_value ("Register :");
        value = get_value ("Value 1 :");
        value2= get_value ("Value 2 :");
        set_double_reg(reg,value,value2);
        break;

      case '3':
        printf("read double reg\n");
        reg = get_value ("Register :");
        c = read_double_reg(reg);
        printf("Value 0x%4x\n",c);
        break;

      case '7':
        printf("init 75 dpi gray scan\n");
        scan_75dpi_gray(198,300,1500);
        break;

      case '8':
        printf("move to pos.\n");
        reg = get_value ("Steps (0..ff (7350)) :");
        value = get_value ("Stepsize (1..ff) :");
        value1 = 1; // get_value ("Speed (1.?) :");
        value2 = get_value ("Forward (2c) / backward(24) :");
        move_pos(reg,value,value1,value2);
        break;

      case '9':
        printf("send moving seq.\n");
        send_moving_seq();
        break;


      case 'a':
        printf("Init grayscale\n");
        gray_init();
        break;

      case 'c':
        printf("Change register\n");
        reg = get_value ("Register :");
        value = get_value ("Value :");
        registers[reg] = value;
        break;

      case 'd':
        printf("Dump registers");
        if (question (" load resisters from Scanner ?") )
          dump_registers(TRUE);
        else
          dump_registers(FALSE);
        break;

      case 'g':
        if(!(data=malloc(0xffffff)))
          {fprintf(stderr,"Cant allocate memory");}
        else
        {
          while(data_ready((unsigned int*) &size)) {
            read_data(size,data_s);
            data_count=0;
          while(size--) fprintf(FD,"%c",data_s[data_count++]);
          };
          free(data_s);
        }
        break;

      case 'q':
        printf("Quit\n");
        exit = 0;
        break;

      case 'h':
        printf("help\n");

        printf("0 - stop moving \n");
        printf("1 - send single reg\n");
        printf("2 - send double reg\n");
        printf("3 - read double reg\n");
        printf("7 - init 75 dpi gray scan\n");
        printf("8 - move to pos.\n");
        printf("9 - send moving seq. \n");
        printf("\n");
        printf("+/- controls the Lamp intensity\n");
        printf("a - Init grayscale\n");
        printf("c - change reg from loaded reg arry \n");
        printf("d - dump loaded reg arry \n");
        printf("l - load reg arry \n");
        printf("m - display Mainboard ID\n");
        printf("o - open testfile test.pnm \n");
        printf("p - move home \n");
        printf("i - Init scanner (calibration)\n");
        printf("r - Read reg\n");
        printf("s - scan preview into file \n");
        printf("t - testscan, starts the scan \n");
        printf("w - write loaded regs in to scanner \n");
        printf("\n");
        printf("h - this help\n");
        printf("\n");
        printf("q - quit\n");
        break;

      case 'm':
        printf("read Mainboard ID\n");
        v = read_reg(0xb1);
        printf("Mainboard ID = 0x%x\n",v);
        break;

      case 'o':
        printf("open testfile\n");
        if(!(data=malloc(0xffffff)))
          {fprintf(stderr,"Cant allocate memory");}
        else
        {
          FD=fopen("test.pnm","w");

          x1 = registers[0x66];
          x1 = x1 + ((registers[0x67] <<8) & 0xFF00);
          x2 = registers[0x6c];
          x2 = x2 + ((registers[0x6d] <<8) & 0xFF00);
          length = registers[0x62] + 1;
          length = length + ((registers[0x63] <<8) & 0xFF00);

          fprintf(FD,"P5\n%d %d\n255\n",x2-x1,length);
        };
        break;

      case 'i':
        printf("Init\n");
        cal_scanner();
        break;

      case 'p':
        printf("Move to home\n");
        park_to_home();
        break;

      case 'r':
        printf("Read reg\n");
        reg = get_value ("Register :");
        v = read_reg(reg);
        printf("Value 0x%x\n",v);
        break;

      case 's':
        printf("scan Preview..\n");
        scan_pv_color(197,10,2600);
        break;

      case 't':
        printf("test scan..\n");
        if(!(data_s=malloc(0xffffff)))
          {fprintf(stderr,"Cant allocate memory\n");}
        else
        {
          x1 = registers[0x66];
          x1 = x1 + ((registers[0x67] <<8) & 0xFF00);
          x2 = registers[0x6c];
          x2 = x2 + ((registers[0x6d] <<8) & 0xFF00);
          length = registers[0x62] + 1;
          length = length + ((registers[0x63] <<8) & 0xFF00);

          printf("scan_region, length:%d, x1:%d, x2:%d \n",length,x1,x2);
          FD=fopen("test75dpi_g_1.pnm","w");
          fprintf(FD,"P5\n%d %d\n255\n",x2-x1,length);

          value = get_value ("1.cmd.:");
          if (value > 0)
             write_reg(0xd3,value);
          send_moving_seq();

//   printf("main0 read_data size %x %x\n",size,&size);
          while(!data_ready((unsigned int*) &size)) sleep(1);
//   printf("main1 read_data size %x %x\n",size,&size);

          while(/*size=*/data_ready((unsigned int*) &size)) {
//   printf("main2 read_data size %x %x\n",size,&size);
            read_data(size,data_s);
            data_count=0;
            while(size--) fprintf(FD,"%c",data_s[data_count++]);
          };
        };
        fclose(FD);
//        free(data);
        free(data_s);

        break;

      case 'w':
        printf("write regs..\n");
          length = 250;
          x1 = 300;
          x2 = 600;
          registers[0x66]=x1 & 0xff;
          registers[0x67]=(x1 >> 8) & 0xff;
          registers[0x6c]=x2 & 0xff;
          registers[0x6d]=(x2 >> 8) & 0xff;
          registers[0x62]=(length+1) & 0xff;
          registers[0x63]=((length+1) >> 8) & 0xff;
        write_bulk_registers(registers,0xb3,0);
        write_bulk_registers(registers+0xb3,0x3f,0xb4);
        break;

      default: printf("?Wrong Key\n");
    };

  };
};

/****************************************************************************/
int main(int argc, char *argv[])
/****************************************************************************/
{
#ifndef REG_EDIT
  int board;
#endif
  device = 0; /*NULL;*/
  printf("Testprogram hp4470c ver. 0.14b\n");
#ifndef M_SCANNER
  int buses,count_devices;
  struct usb_bus* bus;
  usb_init();

#ifdef USBDEBUG
usb_set_debug(30);
#endif

  buses = usb_find_busses();
  count_devices = usb_find_devices();
//  device = scan_bus(usb_busses); change 06.06.03
  for (bus = usb_busses; bus; bus = bus->next) {
       device = scan_bus(bus);
       if (device) {
         printf("Found device!\n");
         break;
       }
   }

#endif

#ifdef M_SCANNER
  device = open_device( );
#endif

  if (device == 0 /*NULL*/)
  {
    printf("No scanner found!!");
    return(1);//	continue;	 not plugged in or in use

  }

/* */
#ifdef TEST
   board = RT_GetVersion();
//   RT_ReadEEPROM();
    printf("Return from ASM : %x\n",board);
#endif
/* */
#ifdef REG_EDIT
  reg_editor();
#else


  if (check_scanner()){
    park_to_home();
  scanner_is_on = TRUE;
  board = RT_GetMainBoardID_call();
  if ( board > 0 ){
    printf("Sorry, your scanner board (%d) not suported yet.\n",board);
    return(1);
  }

//    poll_buttons();
    scan_pv_color(197,10,2600);
//    scan_75dpi_gray(198,300,1500);
//    scan_300dpi_colorn(199,300,1500);
//    scan_150dpi_16_color(198,300,1500);
//    scan_600dpi_color(198,300,1500);
//     move_pos(800,1,FORWARD);
//     move_pos(400,1,REVERSE);


//    park_to_home();
//    switch_off();

    return(0);
  }else{ printf("a connect (r/w) to usb isn't possible, usb_IO_error = 0x%x\n",usb_IO_error); return(1);}
#endif
  return EXIT_SUCCESS;
}

